' ----------------------------------------------------------
' Skriptname: PDFBackGrounderClient
' 
' Autor:    F. Horn (id-netsolutions GmbH)
' Kontakt:  kontakt@id-netsolutions.de
' Support:  support@docufied.de 
'
' ----------------------------------------------------------
' Funktionsbeschreibung
'
' Das Skript macht eine Suche ber eine vorgegbenen Maske
' mit einem Suchkriterium in einem IndexFeld.
' Es wird die ELO Automation Schnittstelle vom PDFBackgrounder
' verwendet.  
' Alle gefunden Dokumente werden vom PDFBackgrounder auf allen 
' Seiten mit einem neuen Hintergrundbild versehen.     
'
' Version: 1.0 
' ----------------------------------------------------------
' Versionsgeschichte
' ----------------------------------------------------------
' 1.0 : 23.02.2010 : Initialversion
' ----------------------------------------------------------
' Module
' Registrierter COM Server "df_PDFBackgrounder.dll"
' ----------------------------------------------------------
' ----------------------------------------------------------
' ----------------------------------------------------------

Set Elo = CreateObject("ELO.professional")

MasKID = 22
IndexID = 0
IndexVal = "DoUpdate"
BackGrDoc = "C:\Devel\docufied PDF Backgrounder\Hintergrunddokumente\Dionys.pdf" ' "52543" ' Entwerde ObjId oder Datei im FS.
 
' Suche
Call Elo.PrepareObjectEx(0, 0, MasKID)
Call Elo.SetObjAttrib(IndexID, IndexVal)
DocCount = Elo.DoInvisibleSearch
msgbox("Gefundene Dokumente in DocCount: " & DocCount)
if DocCount > 0 Then 
  ' Objekt erstellen
  Set dfPdfBG = CreateObject("docufied.PDFBackgrounder")
  ' EloFATClient auf True setzen damit die ELO Automation verwendet wird
  dfPdfBG.EloFATClient = False  ' True = ELO Automation ; False = Indexserver
  ' Muss vor dem ersten aufruf von AddDoc aufgerufen werden.
  ' Elo Objekt wird u. a. Instanziiert
  dfPdfBG.Login
  ' Alle gefunden Dokumente werden mit AddDoc zur Bearbeitung bergeben.
  for i = 0 to DocCount - 1
    ObjId = Elo.GetEntryId(268435456 + i)
    ' msgbox("ObjId : " & ObjId)
    ResAddDoc = dfPdfBG.AddDoc(ObjId, True, False, 0, 0, BackGrDoc, "PDF Backgrounder", &H0200) ' &H0020 = Align placed content to the top.
    if ResAddDoc <> "" Then ' Leersting alles OK, ansonsten Fehlermeldung 
      msgbox(ResAddDoc) 
    End If  
  next
  ProcDocCount = 0 
  ' Fr jedes ber AddDoc hinzugefgte Dokument wird StartProcess mit dem
  ' zu verarbeitenden Index aufgerufen.
  for i = 0 to dfPdfBG.DocCount - 1  ' DocCount gibt die Anzahl der Element zurck die ber AddDoc hinzugefgt wurden.
    io = dfPdfBG.StartProcess(i)     ' Jeder Rckgabewert kleiner 0 ist ein Fehler -> siehe Log oder Doku. fr genaue Beschreibung
    if io < 0 Then 
      msgbox("Fehler Code: " & io & vbcrlf & "Siehe Log oder Doku. fr genaue Beschreibung.")
    else
      ProcDocCount = ProcDocCount + 1  
      ' ggf. Indexzeile von DoUpdate auf UpdateDone setzen -> Verarbeitung abgschlossen
      ObjId = Elo.GetEntryId(268435456 + i)
      io = Elo.PrepareObjectEx(ObjId, 0, 0)
      if io = 2 Then 
        Elo.SetObjAttrib IndexID, "UpdateDone"
        Elo.UpdateObject
      End If  
    End If   
  next
  ' Muss nach dem letzen aufruf von StartProcess aufgerufen werden.
  ' Gibt Objekte wieder frei.
  dfPdfBG.LogOff 
  Set dfPdfBG = Nothing
else
  Msgbox("Es wurden keine Dokumente gefunden!")
End IF 

MsgBox("ENDE!" & vbcrLf & "Es wurden: " & DocCount & " Dokumente bei der Suche gefunden." & vbcrlf & _
       "Es wurden: " & ProcDocCount & " Dokumente erfolgreich bearbeitet!") 
